{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TERATERM.EXE, TEK window message routines}
procedure TEKWindow.WMDestroy(var Msg: TMessage);
begin
  TWindow.WMDestroy(Msg);
  TEKEnd(@tk);
  FreeTTTEK;
  HTEKWin := 0;
  TEKPtr := nil;
  ActiveWin := IdVT;
end;

procedure TEKWindow.WMGetMinMaxInfo(var Msg: TMessage);
begin
with tk do begin
  PMinMaxInfo(Msg.lParam)^.ptMaxSize.X := 10000;
  PMinMaxInfo(Msg.lParam)^.ptMaxSize.Y := 10000;
  PMinMaxInfo(Msg.lParam)^.ptMaxTrackSize.X := 10000;
  PMinMaxInfo(Msg.lParam)^.ptMaxTrackSize.Y := 10000;
end;
end;

procedure TEKWindow.WMInitMenuPopup(var Msg: TMessage);
begin
  TEKInitMenu(@tk,@cv,Msg.wParam);
end;

procedure TEKWindow.WMSysKeyDown(var Msg: TMessage);
begin
  case Msg.wParam of
    VK_F10: WMKeyDown(Msg);
  else
    DefWndProc(Msg);
  end;
end;

procedure TEKWindow.WMSysKeyUp(var Msg: TMessage);
begin
  case Msg.wParam of
    VK_F10: WMKeyUp(Msg);
  else
    DefWndProc(Msg);
  end;
end;

procedure TEKWindow.WMKeyDown(var Msg: TMessage);
begin
  KeyDown(HWindow,Msg.wParam,Msg.lParam and $007f,HiWord(Msg.lParam) and $1ff);
end;

procedure TEKWindow.WMKeyUp(var Msg: TMessage);
begin
  KeyUp(Msg.wParam);
end;

procedure TEKWindow.WMChar(var Msg: TMessage);
var
  i, Count: integer;
  Code: byte;
begin
  if TalkStatus<>IdTalkKeyb then exit;

  Code  := Msg.wParam and $ff;
  Count := Msg.lParam and $007f;

  if tk.GIN then ReportGIN(@tk,@ts,@cv,Code)
  else
    for i := 1 to Count do
    begin
      CommTextOut(@cv,@Code,1);
      if ts.LocalEcho>0 then
      CommTextEcho(@cv,@Code,1);
    end;
end;

procedure TEKWindow.WMActivate(var Msg: TMessage);
begin
with tk do begin
  if boolean(Msg.wParam)
  then begin
    Active := true;
    ChangeCaret(@tk,@ts);
    ActiveWin := IdTEK;
  end
  else begin
    DestroyCaret;
    Active := false;
  end;
end;
end;


procedure TEKWindow.Paint(PaintDC: HDC; var PaintInfo:TPaintStruct);
begin
  TEKPaint(@tk,@ts,PaintDC,@PaintInfo);
end;

procedure TEKWindow.WMLButtonDown(Var Msg: TMessage);
var
  Popup: bool;
  p: TPoint;
begin
  Popup := ControlKey and (Attr.Menu=0);
  p.x := LoWord(Msg.lParam);
  p.y := HiWord(Msg.lParam);

  TEKWMLButtonDown(@tk,@ts,@cv,Popup,p);
  if Popup then
  begin
    ClientToScreen(HWindow, p);
    TrackPopupMenu(tk.PopupBase,TPM_LEFTALIGN or TPM_LEFTBUTTON,
                   p.x,p.y,0,HWindow,nil);
    DestroyMenu(tk.PopupBase);
    DestroyMenu(tk.PopupMenu);
  end
  else
    TWindow.WMLButtonDown(Msg);
end;

procedure TEKWindow.WMLButtonUp(Var Msg: TMessage);
begin
  TEKWMLButtonUp(@tk,@ts);
end;

procedure TEKWindow.WMMButtonUp(Var Msg: TMessage);
begin
  WMRButtonUp(Msg);
end;

procedure TEKWindow.WMRButtonUp(Var Msg: TMessage);
begin
  CBStartPaste(HWindow);
end;

procedure TEKWindow.WMMouseMove(Var Msg: TMessage);
var
  p: TPoint;
begin
  p.x := LoWord(Msg.lParam);
  p.y := HiWord(Msg.lParam);
  TEKWMMouseMove(@tk,@ts,p);
end;

procedure TEKWindow.WMSize(Var Msg: TMessage);
begin
  TWindow.WMSize(Msg);

  if tk.Minimized and (Msg.wParam=SIZE_RESTORED) then
  begin
    tk.Minimized := false;
    exit;
  end;

  if Msg.wParam = SIZE_MINIMIZED then
  begin
    tk.Minimized := true;
    exit;
  end;

  TEKWMSize(@tk,@ts,Attr.W,Attr.H,
            LoWord(Msg.lParam),HiWord(Msg.lParam));
end;

procedure TEKWindow.WMMove(var Msg: TMessage);
begin
  TWindow.WMMove(Msg);
  ts.TEKPos.x := Attr.x;
  ts.TEKPos.y := Attr.y;
end;

procedure TEKWindow.WMSysCommand(var Msg: TMessage);
begin
  case Msg.wParam of
    cm_ShowMenubar:
      begin
        ts.PopupMenu := 0;
        SwitchMenu;
      end;
  else
    DefWndProc(Msg);
  end;
end;

procedure TEKWindow.WMChangeMenu(var Msg: TMessage);
begin
  TEKChangeMenu(@tk,@ts);
  Attr.Menu := tk.MainMenu;
end;

procedure TEKWindow.WMDlgHelp(var Msg: TMessage);
begin
  OpenHelp(tk.HWin,HELP_CONTEXT,HelpId);
end;