{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{TERATERM.EXE, TTSET interface}
unit TTSetup;

interface

uses WinTypes, WinProcs, TTTypes;

type

TReadIniFile = procedure(Fname: PChar; ts: PTTSet);

TWriteIniFile = procedure(Fname: PChar; ts: PTTSet);

TReadKeyboardCnf = procedure(FName: PChar; KeyMap: PKeyMap);

TCopyHostList = procedure(IniSrc, IniDest: PChar);

TParseParam = procedure(Param: PChar; ts: PTTSet; DDETopic: PChar);

var
  HTTSET: THandle;
  ReadIniFile: TReadIniFile;
  WriteIniFile: TWriteIniFile;
  ReadKeyboardCnf: TReadKeyboardCnf;
  CopyHostList: TCopyHostList;
  ParseParam: TParseParam;

function LoadTTSET: bool;
procedure FreeTTSET;

implementation

const
  IdReadIniFile     = 1;
  IdWriteIniFile    = 2;
  IdReadKeyboardCnf = 3;
  IdCopyHostList    = 4;
  IdParseParam      = 5;

function LoadTTSET: bool;
var
  Err: boolean;
begin
  if HTTSET >= 32 then
  begin
    LoadTTSET := true;
    exit;
  end
  else
    LoadTTSET := false;

  HTTSET := LoadLibrary('TTSET.DLL');
  if HTTSET < 32 then exit;

  Err := false;
  @ReadIniFile := GetProcAddress(HTTSet, PChar(IdReadIniFile));
  if @ReadIniFile=nil then Err := true;
  
  @WriteIniFile := GetProcAddress(HTTSet, PChar(IdWriteIniFile));
  if @WriteIniFile=nil then Err := true;

  @ReadKeyboardCnf := GetProcAddress(HTTSet, PChar(IdReadKeyboardCnf));
  if @ReadKeyboardCnf=nil then Err := true;

  @CopyHostList := GetProcAddress(HTTSet, PChar(IdCopyHostList));
  if @CopyHostList=nil then Err := true;

  @ParseParam := GetProcAddress(HTTSet, PChar(IdParseParam));
  if @ParseParam=nil then Err := true;

  if Err then
  begin
    FreeLibrary(HTTSET);
    HTTSET := 0;
  end
  else LoadTTSET := true;

end;

procedure FreeTTSET;
begin
  if HTTSET >= 32 then
  begin
    FreeLibrary(HTTSET);
    HTTSET := 0;
  end;
end;

begin
  HTTSET := 0;
end.