{Tera Term
 Copyright(C) 1994-1996 T. Teranishi
 All rights reserved.}

{Constants and types for Tera Term}
unit TTTypes;

interface

uses WinTypes, WinDos, WinsockH;

const
  MAXPATHLEN = 80;

const
  IdBreakTimer = 1;
  IdDelayTimer = 2;
  IdProtoTimer = 3;
  IdDblClkTimer = 4;
  IdScrollTimer = 5;
  IdComEndTimer = 6;

const
  {Window Id}
  IdVT = 1;
  IdTEK = 2;

const
  {Talker mode}
  IdTalkKeyb = 0;
  IdTalkCB = 1;
  IdTalkFile = 2;
  IdTalkQuiet = 3;

const
  {Character sets}
  IdASCII = 0;
  IdKatakana = 1;
  IdKanji = 2;
  IdSpecial = 3;

const
  {Character attribute bit masks}
  AttrDefault = $00;
  AttrDefault2 = $00;
  AttrBold = $01;
  AttrUnder = $02;
  AttrSpecial = $04;
  AttrFontMask = $07;
  AttrBlink = $08;
  AttrReverse = $10;
  AttrKanji = $80;
  {Color attribute bit masks}
  Attr2Fore = $08;
  Attr2ForeMask = $07;
  Attr2Back = $80;
  Attr2BackMask  = $70;
  SftAttrBack = 4;

const
  {Color codes}
  IdBack    = 0;
  IdRed     = 1;
  IdGreen   = 2;
  IdYellow  = 3;
  IdBlue    = 4;
  IdMagenta = 5;
  IdCyan    = 6;
  IdFore    = 7;

const
  {Kermit function id}
  IdKmtReceive = 1;
  IdKmtGet = 2;
  IdKmtSend = 3;
  IdKmtFinish = 4;

  {XMODEM function id}
  IdXReceive = 1;
  IdXSend = 2;

  {ZMODEM function id}
  IdZReceive = 1;
  IdZSend = 2;
  IdZAuto = 3;

  {B-Plus function id}
  IdBPReceive = 1;
  IdBPSend = 2;
  IdBPAuto = 3;

  {Quick-VAN function id}
  IdQVReceive = 1;
  IdQVSend = 2;

const
  HostNameMaxLength=80;

const
  {internal WM_User messages}
  MsgAccelCommand = 1;
  MsgChangeMenu = 2;
  MsgCloseIME = 3;
  MsgComNotify = 4;
  MsgComOpen = 5;
  MsgComStart = 6;
  MsgDlgHelp2 = 7;
  MsgGetHost = 8;

  MsgDdeReady = 21;
  MsgDdeCmndEnd = 22;
  MsgDdeComReady = 23;
  MsgDdeEnd = 24;

const
  {port type ID}
  IdTCPIP  = 1;
  IdSerial = 2;
  IdFile   = 3;
const
  {XMODEM option}
  XoptCheck = 1;
  XoptCRC   = 2;
  Xopt1K    = 3;
const
  {Language}
  IdEnglish = 1;
  IdJapanese = 2;
type
{Setup record for VT window}
  PTTSet = ^TTTSet;
  TTTSet = record
    Ok: BOOL; {set by TTSET.DLL}

    {Tera Term home directory}
    HomeDir: array [0..MAXPATHLEN-1] of char;
    {Setup file name}
    SetupFName: array [0..MAXPATHLEN-1] of char;
    KeyCnfFN: array [0..MAXPATHLEN-1] of char;
    HostName: array [0..80] of char;

{-------- VTSet --------}
    VTPos: TPoint;
    VTFont: array[0..LF_FACESIZE-1] of char;
    VTFontSize: TPoint;
    VTFontCharSet: integer;
    FontDW, FontDH, FontDX, FontDY: integer;
    PrnFont: array[0..LF_FACESIZE-1] of char;
    PrnFontSize: TPoint;
    PrnFontCharSet: integer;
    EnableBold: word;
    ScrollThreshold: integer;
    CtrlInKanji: BOOL;
    Debug, TelLog, KmtLog, XmodemLog,
    ZmodemLog, ZmodemEscCtl, ZmodemAuto,
    BPLog, QVLog: BOOL;
    ZmodemDataLen, ZmodemWinSize: integer;
    QVWinSize: integer;
    TransBin: word;
    XmodemOpt, XmodemBin: word;
    Append: word;
    FileDir: array[0..fsDirectory] of char;
    Language: word;
{-------- TEKSet --------}
    TEKPos: TPoint;
    TEKFont: array[0..lf_FaceSize-1] of char;
    TEKFontSize: TPoint;
    TEKFontCharSet: integer;
    GINMouseCode: integer;
{-------- TermSet --------}
    TerminalWidth: integer;
    TerminalHeight: integer;
    TermIsWin: word;
    AutoWinResize: word;
    CRSend: word;
    CRReceive: word;
    LocalEcho: word;
    Answerback: array[0..30] of char;
    AnswerbackLen: integer;
    KanjiCode: word;
    KanjiCodeSend: word;
    JIS7Katakana: word;
    JIS7KatakanaSend: word;
    KanjiIn: word;
    KanjiOut: word;
    AutoWinSwitch: word;
    TerminalID: word;
    AllowWrongSequence: BOOL;
    Accept8bitCtrl: BOOL;
    BPAuto: BOOL; {B-plus auto activation}
{-------- WinSet --------}
    VTFlag: BOOL;
    SampleFont: HFont;
    TmpColor: array[0..2, 0..5] of word;
    {Tera Term window setup variables}
    Title: array[0..49] of char;
    CursorShape: word;
    EnableScrollBuff: word;
    ScrollBuffMax: word;
    HideTitle: word;
    PopupMenu: word;
    Dlg3D: word;
    TEKColorEmu: word;
    VTColor: array[0..1] of TColorRef;
    TEKColor: array[0..1] of TColorRef;
    VTBoldColor: array[0..1] of TColorRef;
    VTBlinkColor: array[0..1] of TColorRef;
{-------- KeybSet --------}
    BSKey: word;
    UseIME: word;
    IMEInline: word;
    MetaKey: word;
{-------- PortSet --------}
    PortType: word;
    {TCP/IP}
    TCPPort: word;
    Telnet: word;
    TelBin: word;
    TermType: array[0..40] of char;
    AutoWinClose: word;
    ConfirmDisconn: word;
    {Serial}
    ComPort: word;
    Baud: word;
    Parity: word;
    DataBit: word;
    StopBit: word;
    Flow: word;
    DelayPerChar: word;
    DelayPerLine: word;
  end;

const
  {New Line modes}
  IdCR = 1;
  IdCRLF = 2;
  {Terminal ID}
  IdVT100 = 1;
  IdVT100J = 2;
  IdVT101 = 3;
  IdVT102 = 4;
  IdVT102J = 5;
  IdVT220J = 6;
  IdVT282 = 7;
  IdVT320 = 8;
  IdVT382 = 9;
  {Kanji Code ID}
  IdSJIS = 1;
  IdEUC = 2;
  IdJIS = 3;

  {KanjiIn modes}
  IdKanjiInA = 1;
  IdKanjiInB = 2;
  {KanjiOut modes}
  IdKanjiOutB = 1;
  IdKanjiOutJ = 2;
  IdKanjiOutH = 3;

const
  TermWidthMax = 300;
  TermHeightMax = 200;

const
  {Cursor shapes}
  IdBlkCur = 1;
  IdVCur = 2;
  IdHCur = 3;

const
  IdBS = 1;
  IdDEL = 2;

const
  {Serial port ID}
  IdCOM1 = 1;
  IdCOM2 = 2;
  IdCOM3 = 3;
  IdCOM4 = 4;
  {Baud rate ID}
  IdBaud110 = 1;
  IdBaud300 = 2;
  IdBaud600 = 3;
  IdBaud1200 = 4;
  IdBaud2400 = 5;
  IdBaud4800 = 6;
  IdBaud9600 = 7;
  IdBaud19200 = 8;
  IdBaud38400 = 9;
  IdBaud57600 = 10;

  {Parity ID}
  IdParityEven = 1;
  IdParityOdd = 2;
  IdParityNone = 3;
  {Data bit ID}
  IdDataBit7 = 1;
  IdDataBit8 = 2;
  {Stop bit ID}
  IdStopBit1 = 1;
  IdStopBit2 = 2;
  {Flow control ID}
  IdFlowX = 1;
  IdFlowHard = 2;
  IdFlowNone = 3;


type
{GetHostName dialog record}
  PGetHNRec = ^TGetHNRec;
  TGetHNRec = record
    SetupFN: PChar; {setup file name}
    PortType: word; {TCPIP/Serial}
    HostName: PChar; {host name}
    Telnet: word; {non-zero: enable telnet}
    TCPPort: word;
    COMPort: word;
  end;

{Tera Term internal key codes}
const
  IdUp     =  1;
  IdDown   =  2;
  IdRight  =  3;
  IdLeft   =  4;
  Id0      =  5;
  Id1      =  6;
  Id2      =  7;
  Id3      =  8;
  Id4      =  9;
  Id5      = 10;
  Id6      = 11;
  Id7      = 12;
  Id8      = 13;
  Id9      = 14;
  IdMinus  = 15;
  IdComma  = 16;
  IdPeriod = 17;
  IdEnter  = 18;
  IdPF1    = 19;
  IdPF2    = 20;
  IdPF3    = 21;
  IdPF4    = 22;
  IdFind   = 23;
  IdInsert = 24;
  IdRemove = 25;
  IdSelect = 26;
  IdPrev   = 27;
  IdNext   = 28;
  IdF6     = 29;
  IdF7     = 30;
  IdF8     = 31;
  IdF9     = 32;
  IdF10    = 33;
  IdF11    = 34;
  IdF12    = 35;
  IdF13    = 36;
  IdF14    = 37;
  IdHelp   = 38;
  IdDo     = 39;
  IdF17    = 40;
  IdF18    = 41;
  IdF19    = 42;
  IdF20    = 43;
  IdAccEditCopy = 44;
  IdAccEditPaste = 45;
  IdAccEditPasteCR = 46;
    IdEditPasteCR = 230; {Menu ID}
  IdAccLineUp = 47;
  IdAccLineDown = 48;
  IdAccPageUp = 49;
  IdAccPageDown = 50;
  IdAccBuffTop = 51;
  IdAccBuffBottom = 52;
  IdAccSendBreak = 53;
  IdUser1  = 54;
  NumOfUserKey=99;
  IdKeyMax = IdUser1+NumOfUserKey-1;

  KeyStrMax = 1023;
type
  PKeyMap = ^TKeyMap;
  TKeyMap = record
    Map: array[0..IdKeyMax-1] of word;
    UserKeyStr: array[0..KeyStrMax] of byte;
    {user key conv flag}
    UserKeyConv: array[0..NumOfUserKey-1] of byte;
    {user key str position/length in buffer}
    UserKeyPtr, UserKeyLen: array[0..NumOfUserKey-1] of integer;
  end;

{Control Characters}

const
  NUL = $00;
  SOH = $01;
  STX = $02;
  ETX = $03;
  EOT = $04;
  ENQ = $05;
  ACK = $06;
  BEL = $07;
  BS  = $08;
  HT  = $09;
  LF  = $0A;
  VT  = $0B;
  FF  = $0C;
  CR  = $0D;
  SO  = $0E;
  SI  = $0F;
  DLE = $10;
  DC1 = $11;
    XON = $11;
  DC2 = $12;
  DC3 = $13;
    XOFF = $13;
  DC4 = $14;
  NAK = $15;
  SYN = $16;
  ETB = $17;
  CAN = $18;
  EM  = $19;
  SUB = $1A;
  ESC = $1B;
  FS  = $1C;
  GS  = $1D;
  RS  = $1E;
  US  = $1F;

  SP  = $20;

  DEL = $7F;

  IND = $84;
  NEL = $85;
  SSA = $86;
  ESA = $87;
  HTS = $88;
  HTJ = $89;
  VTS = $8A;
  PLD = $8B;
  PLU = $8C;
  RI  = $8D;
  SS2 = $8E;
  SS3 = $8F;
  DCS = $90;
  PU1 = $91;
  PU2 = $92;
  STS = $93;
  CCH = $94;
  MW  = $95;
  SPA = $96;
  EPA = $97;
  SOS = $98;


  CSI = $9B;
  ST  = $9C;
  OSC = $9D;
  PM  = $9E;
  APC = $9F;

{help file names}
  HelpEng = 'tterm.hlp';
  HelpJpn = 'ttermj.hlp';

{help context numbers}
const
  HlpFileNewConnection = 1;
  HlpFileLog = 2;
  HlpFileSend = 3;
  HlpFileKmtGet = 4;
  HlpFileKmtSend = 5;
  HlpFileXmodemRecv = 6;
  HlpFileXmodemSend = 7;
  HlpFileZmodemSend = 8;
  HlpFileBPlusSend = 9;
  HlpFileQVSend = 10;
  HlpFileChangeDir = 11;
  HlpFilePrint = 12;
  HlpSetupTerminal = 13;
  HlpSetupWindow = 14;
  HlpSetupFont = 15;
  HlpSetupKeyboard = 16;
  HlpSetupSerialPort = 17;
  HlpSetupTCPIP = 18;
  HlpSetupGeneral = 19;
  HlpSetupSave = 20;
  HlpSetupRestore = 21;
  HlpTEKFilePrint = 22;
  HlpTEKSetupWindow = 23;
  HlpTEKSetupFont = 24;

const
  InBuffSize = 1024;
  OutBuffSize = 1024;
type
  PComVar = ^TComVar;
  TComVar = record
    InBuff: array[0..InBuffSize-1] of byte;
    InBuffCount,InPtr: integer;
    OutBuff: array[0..OutBuffSize-1] of byte;
    OutBuffCount,OutPtr: integer;

    HWin: HWnd;
    Ready, Open: BOOL;
    PortType: word;
    ComPort: word;
    saddr: sockaddr_in;
    s: SOCKET;
    RetryCount: word;
    ComID: integer;

    CanSend, RRQ: BOOL;

    SendKanjiFlag: BOOL;
    SendKanjiFirst: byte;
    SendCode: integer;
    EchoKanjiFlag: BOOL;
    EchoKanjiFirst: byte;
    EchoCode: integer;

    {from VTSet}
    Language: word;
    {from TermSet}
    CRSend: word;
    KanjiCodeEcho: word;
    JIS7KatakanaEcho: word;
    KanjiCodeSend: word;
    JIS7KatakanaSend: word;
    KanjiIN: word;
    KanjiOut: word;
    {from PortSet}
    DelayPerChar: word;
    DelayPerLine: word;
    TelBinRecv, TelBinSend: BOOL;

    DelayFlag: BOOL;
    TelFlag, TelMode: BOOL;
    IACFlag, TelCRFlag: BOOL;
    TelCRSend, TelCRSendEcho: BOOL;

    {Text log}
    HLogBuf: THandle;
    LogBuf: pointer;
    LogPtr, LStart, LCount: integer;
    {Binary log & DDE}
    HBinBuf: THandle;
    BinBuf: pointer;
    BinPtr, BStart, BCount, DStart, DCount: integer;
    BinSkip: integer;
    FilePause: BOOL;
  end;

{ VT window menu ID's }
const
  cm_File = 0;
  cm_FileNewConnection = 110;
  cm_FileLog = 120;
  cm_FileSend = 130;
  cm_Transfer = 4;
  cm_FileKermitRcv = 141;
  cm_FileKermitGet = 142;
  cm_FileKermitSend = 143;
  cm_FileKermitFinish = 144;
  cm_FileXRcv = 145;
  cm_FileXSend = 146;
  cm_FileZRcv = 151;
  cm_FileZSend = 152;
  cm_FileBPRcv = 153;
  cm_FileBPSend = 154;
  cm_FileQVRcv = 155;
  cm_FileQVSend = 156;
  cm_FileChangeDir = 170;
  cm_FilePrint = 180;
  cm_FileDisconnect = 190;

  cm_Edit = 1;
  cm_EditPasteCR = IdEditPasteCR;
  cm_EditClearScreen = 240;
  cm_EditClearBuffer = 250;

  cm_Setup = 2;
  cm_SetupTerminal = 310;
  cm_SetupWindow = 320;
  cm_SetupFont = 330;
  cm_SetupKeyboard = 340;
  cm_SetupSerialPort = 350;
  cm_SetupTCPIP = 360;
  cm_SetupGeneral = 370;
  cm_SetupSave = 380;
  cm_SetupRestore = 390;

  cm_Control = 3;
  cm_ControlResetTerminal = 410;
  cm_ControlAreYouThere = 420;
  cm_ControlSendBreak = 430;
  cm_ControlResetPort = 440;
  cm_ControlOpenTEK = 450;
  cm_ControlCloseTEK = 460;
  cm_ControlMacro = 470;

  cm_HelpIndex = 910;
  cm_HelpUsing = 920;
  cm_About = 990;

  cm_ShowMenubar = 995;

implementation

end.
